#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <string>
#include "resource.h"

SC_HANDLE scm;
HINSTANCE g_hInstance;

#define Depend     _T("NVKEYNT\0")
#define DriverName _T("df")
#define Descr      _T("GuardantFilter Driver (v1.1)")

BOOL InstallDriver()
{
	std::string p;
	p.resize(MAX_PATH);
	p.resize(GetSystemDirectory((LPSTR)p.c_str(), MAX_PATH));
	p.append("\\drivers\\df.sys");
	
	SC_HANDLE Service = CreateService(scm, DriverName, Descr,
							SERVICE_ALL_ACCESS, SERVICE_KERNEL_DRIVER, SERVICE_AUTO_START,
							SERVICE_ERROR_NORMAL, p.c_str(), NULL, NULL, Depend, NULL, NULL);
							
	if (!Service)
	{
		DWORD err = GetLastError();
		if (err != ERROR_SERVICE_EXISTS) 
			return FALSE;
	}
	
	CloseServiceHandle(Service);
	return TRUE;
}

BOOL RemoveDriver()
{
	SC_HANDLE Service = OpenService(scm, DriverName, SERVICE_ALL_ACCESS);
	if (!Service) return TRUE;
	
	BOOL ret = DeleteService(Service);
	if (!ret)
	{
		CloseServiceHandle(Service);
		return FALSE;
	}

	CloseServiceHandle(Service);
	return TRUE;
}

BOOL StartDriver()
{
	SC_HANDLE Service =	OpenService(scm, DriverName, SERVICE_ALL_ACCESS);
	if (!Service) return FALSE; 

	SERVICE_STATUS ss;
	QueryServiceStatus(Service, &ss);
	if (ss.dwCurrentState == SERVICE_RUNNING)
	{
		CloseServiceHandle(Service);
		return TRUE;
	}

	BOOL ret = StartService(Service, 0, NULL);
	if (!ret)
	{ 
		CloseServiceHandle(Service);
		return FALSE;
	}

	CloseServiceHandle(Service);
	return TRUE;
}

BOOL StopDriver()
{
	SC_HANDLE Service = OpenService(scm, DriverName, SERVICE_ALL_ACCESS);
	if (!Service)	return TRUE;

	SERVICE_STATUS ss;
	QueryServiceStatus(Service, &ss);
	if (ss.dwCurrentState == SERVICE_STOPPED)
	{
		CloseServiceHandle(Service);
		return TRUE;
	}

	SERVICE_STATUS serviceStatus;
	BOOL ret = ControlService(Service, SERVICE_CONTROL_STOP, &serviceStatus);
	if (!ret)
	{
		CloseServiceHandle(Service);
		return FALSE;
	}

	CloseServiceHandle(Service);
	return TRUE;
}

INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_INITDIALOG:
		{
			break;
		}
		case WM_CLOSE:
		{
			PostQuitMessage(0);
			break;
		}
		case WM_COMMAND:
		{
			switch (wParam)
			{
				case IDC_BUTTON_INSTALL:
				{
					StopDriver();
					std::string p;
					p.resize(MAX_PATH);
					p.resize(GetSystemDirectory((LPSTR)p.c_str(), MAX_PATH));
					p += "\\drivers";
					CopyFile("df.sys", (p + "\\df.sys").c_str(), false);
					
					SHFILEOPSTRUCT sf;
					sf.hwnd = hwndDlg;
					sf.wFunc = FO_COPY;
					sf.pFrom = _T("*.bin");
					sf.pTo = p.c_str();
					sf.fFlags = FOF_SILENT | FOF_NOCONFIRMATION;
					sf.fAnyOperationsAborted = FALSE;
					SHFileOperation(&sf);
					
					if (InstallDriver())
					{
						ShellExecute(hwndDlg, NULL, "regedit", "/s key.reg", NULL, SW_HIDE);
						if (StartDriver())
							MessageBox(hwndDlg, "  !", "", 0);
						else
							MessageBox(hwndDlg, "   !", "", 0);
					}
					else
						MessageBox(hwndDlg, "   !", "", 0);
						
					break;
				}
				case IDC_BUTTON_UNINSTALL:
				{
					if (StopDriver())
					{
						if (RemoveDriver())
							MessageBox(hwndDlg, "  !", "", 0);
						else
							MessageBox(hwndDlg, "   !", "", 0);
							
						std::string p;
						p.resize(MAX_PATH);
						p.resize(GetSystemDirectory((LPSTR)p.c_str(), MAX_PATH));
						p += "\\drivers\\df.sys";
						DeleteFile(p.c_str());
					}
					else
						MessageBox(hwndDlg, "   !", "", 0);
					break;
				}
			}
			break;
		}
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	g_hInstance = hInstance;
	scm = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

	if(!scm) 
	{
		MessageBox(0, "  SC Manager'a", "", 0);
		return -1;
	}

	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOGMAIN), 0, &DialogProc);

	CloseServiceHandle(scm);
	return 0;
}
