#ifndef _NVUTILS_H
#define _NVUTILS_H

#define USE_EMUL

#ifdef __cplusplus
extern "C"
{
#endif

#include <wdm.h>
#include "nvsk_sys.h"
#include <stdlib.h>

#ifdef __cplusplus
}
#endif

class CGuardantEmul
{
public:
	CGuardantEmul(ULONG inPrivateKey, HANDLE inMainKey) : m_privateKey(inPrivateKey), 
		hMainKey(inMainKey) {};

	int nskCheck();

	void nskEnvelope(ULONG *Question);
	void nskTransform(ULONG position, unsigned char *buf);
	void nskCodeInit(unsigned char *buf);

	void nskReadUAM(ULONG position, int size, unsigned char *buf);
	void nskReadSAM(ULONG position, int size, unsigned char *buf);

	void nskFind(ULONG inPrivateKey, unsigned char *buf);

	void PrintBuffer(unsigned char *buf, int size);
private:
	HANDLE hMainKey;
	ULONG  m_privateKey;
};

class CStealthAptusEmul
{
public:
	CStealthAptusEmul(const char *inPrivateKey, HANDLE inMainKey) : hMainKey(inMainKey) 
	{
		mbstowcs(m_privateKey, inPrivateKey, strlen(inPrivateKey) + 1);
	};

	int  nskCheck();
	void nskReadUAM(ULONG position, int size, unsigned char *buf);
	void nskReadSAM(ULONG position, int size, unsigned char *buf);
private:
	HANDLE  hMainKey;
	wchar_t m_privateKey[10];
};

#endif // _NVUTILS_H

